extern crate winapi;
use std::io::Error;

fn run_command(cmd: &str) -> Result<i32, Error> {
    use std::mem;
    use std::ffi::OsStr;
    use std::iter::once;
    use std::os::windows::ffi::OsStrExt;
    use std::ptr::null_mut;
    use winapi::shared::minwindef::{ BOOL, DWORD };
    use winapi::um::processthreadsapi::{ CreateProcessW, 
                                         STARTUPINFOW, 
                                         PROCESS_INFORMATION };

    let mut cmdline: Vec<u16> = OsStr::new(cmd).encode_wide().chain(once(0)).collect();
    let mut sinfo: STARTUPINFOW = unsafe { mem::zeroed() };
    sinfo.cb = mem::size_of::<STARTUPINFOW>() as DWORD;
    let mut pinfo: PROCESS_INFORMATION = unsafe { mem::zeroed() };

    let ret = unsafe {
        CreateProcessW( null_mut(), 
                        cmdline.as_mut_ptr(), 
                        null_mut(), 
                        null_mut(), 
                        false as BOOL,
                        0,
                        null_mut(),
                        null_mut(),
                        &mut sinfo,
                        &mut pinfo )
    };
    if ret == 0 { Err(Error::last_os_error()) }
    else        { Ok(ret) }
}

fn main() {
    run_command("notepad.exe").unwrap();
    println!("done");
}

/*
CreateProcess( NULL, 
               lpCommandLine, 
               NULL, 
               NULL, 
               FALSE,
               NORMAL_PRIORITY_CLASS | CREATE_NEW_CONSOLE,
               NULL, 
               NULL, 
               &startInfo, 
               &processInfo )
*/
