extern crate winapi;
use std::io::Error;

fn main() {
    use std::{thread, time};
    use winapi::um::winbase::{ GetProcessAffinityMask };
    use winapi::um::processthreadsapi::{ GetCurrentProcess,
                                         GetCurrentProcessId,
                                         GetCurrentProcessorNumber };

    let process_handle = unsafe { GetCurrentProcess() };
    let process_id     = unsafe { GetCurrentProcessId() };

    loop {
        let processor_number = unsafe { GetCurrentProcessorNumber() }; 

        let mut process_affinity_mask = 0; 
        let mut  system_affinity_mask = 0; 
        let ret = unsafe { 
            GetProcessAffinityMask( process_handle, 
                                    &mut process_affinity_mask, 
                                    &mut  system_affinity_mask ) 
        };
        if ret == 0 { Err(Error::last_os_error()) }
        else        { Ok(ret) }.unwrap();

        /* count the number of processors set in the affinity mask */
        let mut processor_count = 0;
        let mut mask = 1;
        for _i in 1..64 {
            if 0 < mask & process_affinity_mask {
                processor_count += 1;
            }
            mask <<= 1;
        }
        println!("process_id = {}, process_affinity_mask = {}, processor_count = {}, processor_number = {}",
                  process_id,      process_affinity_mask,      processor_count,      processor_number);

        thread::sleep( time::Duration::from_millis(1000) );
    }
}
