/*
   Must be compiled with a 64 bit compiler.
*/
#include <windows.h>
#include <stdio.h>

int main() {
   HANDLE hProcess = GetCurrentProcess();
   DWORD processId = GetCurrentProcessId();
   DWORD_PTR processAffinityMask;  /* 64 bit data type */
   DWORD_PTR  systemAffinityMask;  /* 64 bit data type */
   int processorNumber;

   while(1) {
      GetProcessAffinityMask(hProcess,
                             &processAffinityMask,
                             &systemAffinityMask);
      processorNumber = GetCurrentProcessorNumber(); /* 64 bit function */

      /* count the number of processors set in the affinity mask */
      int processorCount = 0;
      int mask = 1;
      for (int i = 1; i <= 64; i++) { /* limit the number of processors to 64 */
         if ( mask & processAffinityMask )
            processorCount++;
         mask <<= 1;
      }
      printf("processId = %d, processAffinityMask = %d, processorCount = %d, processorNumber = %d\n",
         (int)processId, (int)processAffinityMask,      processorCount,      processorNumber);
      Sleep(1000);
   }
   return 0;
}
